#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("cmlsc.in");
ofstream fout("cmlsc.out");

const int MaxN = 101, Inf = 0x3f3f3f3f;
int a[MaxN], n;
int L[MaxN]; /// L[i] - c.m.l.s.c care "se termina" cu a[i]
int Lmax;

void ReadArray();
void Cmlsc();

int main()
{
    ReadArray();
    Cmlsc();
    fout << Lmax << '\n';
    for (int i = 1; i <= n; ++i)
        fout << L[i] << ' ';

    fin.close();
    fout.close();
}

void Cmlsc()
{
    L[1] = 1;
    Lmax = 1;
    for (int i = 2; i <= n; ++i)
    {
        int lmax = -Inf;
        for (int j = 1; j < i; ++j)
            if (a[j] < a[i])
                lmax = max(lmax, L[j]);

        if ( lmax != -Inf )
            L[i] = lmax + 1;
        else
            L[i] = 1;
        Lmax = max(Lmax, L[i]);
    }

}

void ReadArray()
{
    fin >> n;
    for(int i = 1; i <= n; ++i)
        fin >> a[i];
}
