#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("cmlsc.in");
ofstream fout("cmlsc.out");

const int MaxN = 101;
int a[MaxN], n;
int R[MaxN]; /// R[i] - c.m.l.s.c care "incepe" cu a[i]
int Lmax;

void ReadArray();
void Cmlsc();

int main()
{
    ReadArray();
    Cmlsc();
    fout << Lmax << '\n';

    fin.close();
    fout.close();
}

void Cmlsc()
{
    for (int i = n; i >= 1; --i)
    {
        R[i] = 1;
        for (int j = i + 1; j <= n; ++j)
            if (a[i] < a[j])
                R[i] = max(R[i], R[j] + 1);

        Lmax = max(Lmax, R[i]);
    }
}

void ReadArray()
{
    fin >> n;
    for(int i = 1; i <= n; ++i)
        fin >> a[i];
}
