#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("cmlsc.in");
ofstream fout("cmlsc.out");

const int MaxN = 101, Inf = 0x3f3f3f3f;
int a[MaxN], n;
int L[MaxN]; /// L[i] - c.m.l.s.c care "se termina" cu a[i]
int Lmax;

void ReadArray();
void Cmlsc();

int main()
{
    ReadArray();
    Cmlsc();
    fout << Lmax << '\n';

    fin.close();
    fout.close();
}

void Cmlsc()
{
    for (int i = 1; i <= n; ++i)
    {
        L[i] = 1;
        for (int j = 1; j < i; ++j)
            if (a[j] < a[i])
                L[i] = max(L[i], L[j] + 1);

        Lmax = max(Lmax, L[i]);
    }
}

void ReadArray()
{
    fin >> n;
    for(int i = 1; i <= n; ++i)
        fin >> a[i];
}
