#include <fstream>
#include <cstring>
#include <algorithm>
using namespace std;

ifstream fin("palin.in");
ofstream fout("palin.out";)
const int MaxN = 101, Inf = 0x3f3f3f3f;
int n;
char a[MaxN];
int nrp[MaxN];  /// nrp[i] - nr minim de palindroame in care poate fi partitionata
               /// secventa s[0...i]

bool Pal(int i, int j);

int main()
{
    fin >> s;
    n = strlen(s);

    for (int i = 0; i < n; ++i)
    {
        nrp[i] = Inf;
        if (Pal(0, i))
            nrp[i] = 1;
        else
            for (int j = 0; j < i; ++j)
                if (Pal(j + 1, i) && nrp[j] + 1 < nrp[i])
                    nrp[i] = nrp[j] + 1;
    }

    fout << nrp[n - 1];

    fin.close();
    fout.close();
}

bool Pal(int i, int j)
{
    while (i <= j)
    {
        if (s[i] != s[j])
            return false;
        i++, j--;
    }
    return true;
}
